<?php
/* MySQL Kommentarfunktion - Webbausteine.de

   Version vom: 01.11.2014
   Eine Aktuelle Version finden Sie unter:
   http://www.webbausteine.de/blog/mysql/mysql_kommentarfunktion.php
   Dort knnen Sie auch Verbesserungsvorschlge und Hinweise eintragen.

   Mit der MySQL-Kommentarfunktion knnen Besucher Kommentare auf
   der Seite hinterlassen.

   - In Beliebig viele Seiten kann die Kommentarfunktion eingebunden werden.
   - Die Kommentare werden in einer MySQL-Datenbank gespeichert.
   - Der Admin erhlt eine E-Mail bei einem Kommentar.
   - Die Kommentare knnen gesperrt, gendert oder gelscht werden.
   - Sicherheitsabfrage (Spamschutz), BB-Code, Smileys, Bewertung
   - Mehrere Zeilenumbrche hintereinander (vom Benutzer) werden gelscht.
   - Aufteilung der Kommentare auf mehrere Seiten (Blttersystem).

   Funktionsweise:
    Nachdem ein Besucher einen Kommentar eingetragen hat,
    werden Sie ber E-Mail benachrichtigt.
    Zum freischalten des Kommentars klicken Sie auf den in der E-Mail enthaltenen Link
     (den Link eventuell kopieren und in die Adresszeile des Browsers einfgen!).
    Es ffnet sich ein Browser-Fenster auf der erscheinenden Seite mssen Sie Ihr
    Passwort eingeben, hier knnen Sie den Kommentar gegeben falls editieren
    (oder etwas dazu schreiben), und auf "Ausfhren" klicken.
    Optional haben Sie die Mglichkeit, die Kommentare direkt nach dem eintragen
    anzeigen zu lassen.

   Das Einbinden der Kommentarfunktion in eine Seite ist denkbar einfach:
   <?php include "kommentar.php"; ?>
    In der Datei: "demoseite.php" finden Sie eine Demo dazu.

   Installation - Fhren Sie folgende Anweisungen nacheinander aus:
    1. In dieser Datei passen Sie die Einstellungen an.
    2. Laden Sie alle Dateien auf Ihrem Webserver hoch.
    3. Rufen Sie die Datei "kommentar.php?aktion=install" in Ihrem Browser auf.
    4. Geben Sie Ihr Passwort ein und drcken auf dem Button "Ausfhren"


   Lizenzbedingungen
    Mit dem Einsatz der Scripte akzeptieren Sie unser Lizenzabkommen ohne Einschrnkungen.
    Die Scripte sind fr die private und kommerzielle Verwendung kostenlos.
    Wir bernehmen keinerlei Haftung bezglich der Funktionstchtigkeit oder irgendwelchen Schadens- 
    oder Ersatzansprchen, die sich bei der Nutzung der Scripte ergeben.
    Es wird kein Support fr Probleme geben, die bei der Anpassung der Scripte entstehen.

   Werner Zenk -  www.webbausteine.de */


// Einstellungen

// E-Mail
$EMAIL = "name@example.com";

// Passwort
$PASSWORT = "user";

// Sperre der Anzeige (0 oder 1 = Der Kommentar
// ist nach dem eintragen sofort sichtbar!)
$ANZEIGESPERRE = 0;

// Anzahl der Kommentare pro Seite anzeigen
$KOMENTARE_SEITE = 10;

// BB-Code Buttons zum einfgen in das Textfeld.
// Bei einer nderung sind weitere Einstellungen in der Funktion bbcode() ntig!
// Leeren, wenn keine Buttons angezeigt werden sollen.
$BB_CODE = "[b], [i], [s], [u]";

// Verbindungsdaten zur Datenbank
$DB_HOST = "localhost"; // Datenbank-Host
$DB_NAME = "test"; // Datenbank-Name
$DB_BENUTZER = "root"; // Datenbank-Benutzer
$DB_PASSWORT = ""; // Datenbank-Passwort

// Name der Tabelle (muss normalerweise nicht gendert werden!)
$TABELLENNAME = "kommentare";


// Fortgeschrittene Anwender knnen ab hier nderungen vornehmen.

// PHP-Version vergleichen
if (version_compare(PHP_VERSION, '5.1.0') < 0) die('<p>Aktuelle PHP-Version: ' . PHP_VERSION . '<br>Voraussetzung mind.: 5.1.0</p>');

try {
 // Verbindung zur Datenbank aufbauen
 $verbindung = new PDO("mysql:host=" . $DB_HOST . ";dbname=" . $DB_NAME, $DB_BENUTZER, $DB_PASSWORT);
}
catch (PDOException $e) {
 // Bei einer fehlerhaften Verbindung eine Nachricht ausgeben
 exit("Verbindung fehlgeschlagen! " . $e->getMessage());
}

// Dateipfad ermitteln
$pfad = str_replace("www.", "", $_SERVER["SERVER_NAME"] . $_SERVER["SCRIPT_NAME"]);
if (basename($pfad) == "kommentar.php" && !isset($_GET["aktion"])) exit;

// JavaScript-Funktion
$javascript = '<script>function button(taste){if (document.getSelection){var field=document.Form.text;var startPos=field.selectionStart;var endPos=field.selectionEnd;var txt=field.value.substring(startPos, endPos);if(txt!=""){field.value=field.value.substring(0,startPos)+"["+taste+"]"+txt+"[/"+taste+"]"+field.value.substring(endPos, field.length);}else{document.Form.text.value=document.Form.text.value+="["+taste+"][/"+taste+"]";}}}</script>';

// Aktionen ausfhren
if (isset($_GET["aktion"])):
 switch($_GET["aktion"]):


  // Kommentar berprfen, eintragen und E-Mail versenden
  case "eintragen":
   $fehler = "";
   // berprfung
   if (md5($_POST["zip"]) != $_POST["zip2"]) $fehler .= 'Die Rechenaufgabe ist falsch!<br>';
   if (strlen($_POST["text"]) < 15) $fehler .= 'Bitte geben Sie einen Kommentar ein!<br>';
   if (strip_tags($_POST["text"]) != $_POST["text"] || strip_tags($_POST["name"]) != $_POST["name"]) $fehler .= 'HTML-Tags sind nicht erlaubt!<br>';
   if (strlen($_POST["name"]) <= 3) $fehler .= 'Bitte geben Sie einen Namen ein!';
   if (empty($fehler)) {
    $_POST["text"] = preg_replace('/\n/', '', preg_replace('/(\s{2})\s+/', '$1', $_POST["text"]));
    // Eintragen
    $kommando = $verbindung->prepare("INSERT INTO `" . $TABELLENNAME . "`
                                                              SET
                                                                `pfad`= :pfad,
                                                                `anzeige`= :anzeige,
                                                                `name`= :name,
                                                                `text`= :text,
                                                                `bewertung`= :bewertung,
                                                                `datum`= NOW()");
    $kommando->bindParam(':pfad', $pfad);
    $kommando->bindParam(':anzeige', $ANZEIGESPERRE);
    $kommando->bindParam(':name', $_POST["name"]);
    $kommando->bindParam(':text', $_POST["text"]);
    $kommando->bindParam(':bewertung', $_POST["bewertung"]);
    if ($kommando->execute()) {
     $id = $verbindung->lastInsertId();
     print '<fieldset>
             <legend> <a id="anker"></a> Kommentar eingetragen </legend>
             <p>&#10004; Vielen Dank <i>' . $_POST["name"] . '</i>, <br>der Kommentar wurde eingetragen.
              ' . ($ANZEIGESPERRE == 0 ?
                   '<br>Dieser wird vor der Verffentlichung geprft,<br>daher kann es etwas dauern bis dieser erscheint.' :
                   '') . '
             </p>
           </fieldset>
           ';
     // E-Mail an den Admin versenden
     @mail($EMAIL,
               "Kommentar: " . $_POST["titel"],
                  "Datum: " . date("d.m.Y H:i") .
                  " Uhr\nTitel der Seite: " . $_POST["titel"] .
                  "\nName: " . $_POST["name"] .
                  "\nKommentar:\n" . $_POST["text"] .
                  "\n\nBearbeiten: http://" . $pfad . "?aktion=bearbeiten&id=" . $id . "#anker\n",
               "From:" . $EMAIL);
    }
   }
   else {
    print '<fieldset>
             <legend> <a id="anker"></a> Eingabefehler </legend>
             <h3>&#10008; Der Kommentar wurde aus folgendem Grund nicht eingetragen:</h3>
             <p>' . $fehler . '</p>
             &laquo; <a href="javascript:history.back()">Zurck zum Formular</a>
            </fieldset>
         ';
   }
  break;


  // Kommentar bearbeiten
  case "bearbeiten":
  $kommando = $verbindung->prepare("SELECT `id`, `anzeige`, `name`, `text`, `bewertung`
                                                            FROM `" . $TABELLENNAME . "`
                                                            WHERE `id`= :id");
  $kommando->bindParam(':id', $_GET["id"]);
  $kommando->execute();
  $datensatz = $kommando->fetchAll(PDO::FETCH_OBJ);
   if (count($datensatz) == 1) {
    print $javascript . '<form name="Form" action="' . $_SERVER["SCRIPT_NAME"] . '?aktion=aendern#anker" method="post">
            <fieldset>
            <p style="background: Whitesmoke;">' . bbcode($datensatz[0]->text) . '</p>
            <legend> <a id="anker"></a> Kommentar bearbeiten </legend>
             <label> Name: * <input type="text" name="name" value="' . $datensatz[0]->name . '" size="50" required="required"> </label> &nbsp; 
              ' . (bewertung($datensatz[0]->bewertung)) . '<br><br>
             <label for="kmt"> Kommentar: *</label> &emsp;
              ' . (buttons($BB_CODE)) . '<br>
             <textarea name="text" id="kmt" rows="15" cols="70" required="required">' . $datensatz[0]->text . '</textarea> <br><br>
             <label> Anzeige ist ' . ($datensatz[0]->anzeige == 1 ? 'offen' : 'gesperrt') . ': 
             <select name="anzeige" size="1">
              <option value="1">ffnen</option>
              <option value="0">Sperren</option>
             </select> </label> &emsp; 
             <label> <input type="radio" name="auswahl" value="delete"> Lschen </label> 
             <label> <input type="radio" name="auswahl" value="edit" checked="checked"> ndern </label><br><br>
             <input type="hidden" name="id" value="' . $datensatz[0]->id . '">
             <label> Passwort: * <input type="password" name="passwort" required="required"> </label>
             &emsp; <input type="submit" value="Ausfhren">
            </fieldset>
           </form>
         ';
   }
  break;


  // Kommentar ndern/lschen
  case "aendern":
   if ($_POST["passwort"] == $PASSWORT) {
    // ndern
    if ($_POST["auswahl"] == "edit") {
     $kommando = $verbindung->prepare("UPDATE `" . $TABELLENNAME . "`
                                                               SET 
                                                                  `name` = :name,
                                                                  `text` = :text,
                                                                  `anzeige` = :anzeige
                                                               WHERE
                                                                  `id` = :id");
     $kommando->bindParam(':name', $_POST["name"]);
     $kommando->bindParam(':text', $_POST["text"]);
     $kommando->bindParam(':anzeige', $_POST["anzeige"]);
     $kommando->bindParam(':id', $_POST["id"]);
     if ($kommando->execute()) {
      print '<h3> <a id="anker"></a> &#10004; Der Kommentar wurde gendert. </h3>';
     }
    }
    // Lschen
    if ($_POST["auswahl"] == "delete") {
     $kommando = $verbindung->prepare("DELETE FROM `" . $TABELLENNAME . "`
                                                                WHERE `id` = :id");
     $kommando->bindParam(':id', $_POST["id"]);
     if ($kommando->execute()) {
      print '<h3> <a id="anker"></a> &#10004; Der Kommentar wurde gelscht. </h3>';
     }
    }
   }
   else {
    print '<h3> <a id="anker"></a> &#10008; Das Passwort ist falsch! </h3>';
   }
  break;


  // Installation
  case "install":
   print '<form action="' . $_SERVER["SCRIPT_NAME"] . '?aktion=install_start" method="post">
            <fieldset>
           <legend> Datenbank-Tabelle "' . $TABELLENNAME . '" fr Kommentare erstellen </legend>
            <label> Passwort: <input type="password" name="passwort" required="required"> </label>
            <input type="submit" value="Ausfhren">
           </fieldset>
          </form>
        ';
  break;


  // Installation starten
  case "install_start":
   if ($_POST["passwort"] == $PASSWORT) {
    if ($verbindung->query("CREATE TABLE IF NOT EXISTS `" . $TABELLENNAME . "` (
                                         `id` INT NOT NULL AUTO_INCREMENT PRIMARY KEY ,
                                         `pfad` VARCHAR(250) NOT NULL ,
                                         `anzeige` TINYINT(1) NOT NULL ,
                                         `name` VARCHAR(45) NOT NULL ,
                                         `text` TEXT NOT NULL ,
                                         `bewertung` TINYINT(1) NOT NULL ,
                                         `datum` DATETIME NOT NULL
                                      ) ENGINE = MYISAM")) {
     print '<h3> &#10004; Die Datenbanktabelle wurde erstellt. </h3>';
     print file_exists("demoseite.php") ? '<a href="demoseite.php">Zur Demoseite</a>' : '';
    }
    else {
     print '<h3> &#10008; Fehler beim erstellen der Datenbanktabelle. </h3>';
     print_r($verbindung->errorInfo());
    }
   }
   else {
    print '<h3> &#10008; Das Passwort ist falsch! </h3>';
   }
  break;
  default:
   exit('<h3> &#10008; Fehler beim Funktionsaufruf! </h3>');
 endswitch;
endif;


// Anzahl der Seiten berechnen
$select = $verbindung->query("SELECT `id` FROM `" . $TABELLENNAME . "` WHERE `pfad` = '" . $pfad . "' AND `anzeige` = '1'");
@$AnzahlDatensaetze = $select->rowCount();
if ($AnzahlDatensaetze > 0) {
 $AktuelleSeite = isset($_GET["seite"]) ?  intval($_GET["seite"]) : 1;
 $Seitenanzahl = ceil($AnzahlDatensaetze / $KOMENTARE_SEITE);
 $AktuelleSeite = $AktuelleSeite < 1 || $AktuelleSeite > $Seitenanzahl ? 1 : $AktuelleSeite;
 $Versatz = $AktuelleSeite * $KOMENTARE_SEITE - $KOMENTARE_SEITE;

 // Kommentare auslesen
 $kommando = $verbindung->query("SELECT `name`, `text`, `bewertung`, `datum`
                                                        FROM `" . $TABELLENNAME . "`
                                                        WHERE `pfad` = '" . $pfad . "'
                                                        AND `anzeige` = '1'
                                                        ORDER BY `datum` ASC
                                                        LIMIT "  . $Versatz . ", " . $KOMENTARE_SEITE);
 if ($datensaetze = $kommando->fetchAll(PDO::FETCH_OBJ)) {
   print '<fieldset> <legend> <a id="comments"></a> ' . $AnzahlDatensaetze . ' Kommentar' . ($AnzahlDatensaetze > 1 ? 'e' : '') . (
    (count($datensaetze) >= 5 && !isset($_GET["aktion"])) ? ' - &raquo; <a href="#anker">Kommentar eintragen</a>' : '') . ' </a> </legend>';

   // Navigation
   if ($AnzahlDatensaetze > $KOMENTARE_SEITE) {
   print  '<p>Seite: ' . $AktuelleSeite . ' von ' . $Seitenanzahl . ' &emsp; ' .
   (($AktuelleSeite - 1) > 0 ? '&laquo; <a href="?seite=' . ($AktuelleSeite - 1) . '#comments">Zurck</a>&nbsp; ' : '') . ' ' .
   (($AktuelleSeite + 1)  <= $Seitenanzahl ? '<a href="?seite=' . ($AktuelleSeite + 1) . '#comments">Weiter</a> &raquo;' : '') . '</p>';
   }

   // Kommentare anzeigen
   foreach($datensaetze as $datensatz) {
    sscanf($datensatz->datum, "%4s-%2s-%2s %5s", $jahr, $monat, $tag, $zeit);
    print '<p><b>' . $datensatz->name . '</b><small> - ' . $tag . '.' . $monat . '.' . $jahr . ' - ' . $zeit . ' Uhr</small>&nbsp;' .
     bewertung($datensatz->bewertung) . '<br>' . 
     bbcode($datensatz->text) . '</p>';
   }
   print '</fieldset>';
 }
}


// Formular anzeigen
if (!isset($_GET["aktion"])):

 // Sicherheitsabfrage
 $z0 = array(mt_rand(1, 9), mt_rand(1, 9));
 $z1 = max($z0); $z2 = min($z0);
 $spam = $z1 . " &#43; &#" . (48 + $z2) . ";";
 $schutz = md5($z1 + $z2);

 print $javascript . '<form name="Form" action="' . $_SERVER["SCRIPT_NAME"] . '?aktion=eintragen#anker" method="post">
 <fieldset>
 <legend> <a id="anker"></a> Kommentar eintragen </legend>
 <p>
  <label> Name: * <input type="text" name="name" size="35" maxlength="40" required="required"> </label> &emsp;
  <label>Bewertung: 
  <select name="bewertung">
   <option value="0"></option>
   <option value="1">&#10026;</option>
   <option value="2">&#10026; &#10026;</option>
   <option value="3">&#10026; &#10026; &#10026;</option>
  </select></label><br><br>
  <label for="kmt"> Kommentar:</label> * &emsp; 
   ' . (buttons($BB_CODE)) . '<br>
  <textarea name="text" id="kmt" rows="12" cols="60" required="required" spellcheck="true"></textarea> <br><br>
  <label> Sicherheitsabfrage: * &emsp; 
  <em>' . $spam . '</em> = 
  <input type="text" name="zip" size="4" required="required" autocomplete="off"> </label> &emsp; 
  <input type="hidden" name="zip2" value="' . $schutz . '">
  <script> document.write(\'<input type="hidden" name="titel" value="\' + document.title + \'">\'); </script>
  <input type="submit" value="Kommentar eintragen">
 </p>
 </fieldset>
</form>
 ';
endif;

// BB-Code
function bbcode($text) {
 // Bildpfade eventuell anpassen!
 $smiley = array(
  ":)" => '<img src="laecheln.gif" alt="">',
  ":(" => '<img src="traurig.gif" alt="">',
  ";)" => '<img src="zwinkern.gif" alt="">',
 );
 $text = strtr($text, $smiley);
 $text = preg_replace(
  array(
   "/\[b\](.*)\[\/b\]/Usi",
   "/\[i\](.*)\[\/i\]/Usi",
   "/\[s\](.*)\[\/s\]/Usi",
   "/\[u\](.*)\[\/u\]/Usi",
         ),
 array (
   "<b>\\1</b>",
   "<i>\\1</i>",
   "<s>\\1</s>",
   "<u>\\1</u>",
         ), $text);
 return nl2br($text);
}

// Bewertung
function bewertung($punkte) {
 if ($punkte < 1) return;
 return ($punkte > 0 ? '<span class="bewertung_ok">&thinsp;' . str_repeat('&#10026;' , $punkte) . '</span>' : "") .
 ((3 - $punkte) > 0 ? '<span class="bewertung_ko">' . str_repeat('&#10026;' , (3 - $punkte)) . '</span>' : "");
}

// Buttons
function buttons($BB_CODE) {
 $array = explode(",", $BB_CODE);
 $var = "";
 foreach ($array as $element) {
  if ($element != "") {
   $button = str_replace(array("[", "]"), "", trim($element));
   $var .= '<input type="button" class="button" value="' . $button . '" onClick="button(\'' . $button . '\')"> ';
  }
 }
 return $var != "" ? $var : "";
}
?>